/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 374:  /* atomic_cas_value_nand_7_di */
    case 373:  /* atomic_cas_value_nand_7_si */
    case 372:  /* atomic_cas_value_or_7_di */
    case 371:  /* atomic_cas_value_or_7_si */
    case 370:  /* atomic_cas_value_xor_7_di */
    case 369:  /* atomic_cas_value_xor_7_si */
    case 368:  /* atomic_cas_value_and_7_di */
    case 367:  /* atomic_cas_value_and_7_si */
    case 366:  /* atomic_cas_value_sub_7_di */
    case 365:  /* atomic_cas_value_sub_7_si */
    case 364:  /* atomic_cas_value_add_7_di */
    case 363:  /* atomic_cas_value_add_7_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 4));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[8] = *(ro_loc[8] = &XEXP (XVECEXP (pat, 0, 3), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 376:  /* atomic_cas_value_exchange_7_di */
    case 375:  /* atomic_cas_value_exchange_7_si */
    case 362:  /* atomic_cas_value_cmp_and_7_di */
    case 361:  /* atomic_cas_value_cmp_and_7_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 4));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 360:  /* atomic_cas_value_strongdi */
    case 359:  /* atomic_cas_value_strongsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 358:  /* atomic_exchangedi */
    case 357:  /* atomic_exchangesi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 356:  /* atomic_fetch_anddi */
    case 355:  /* atomic_fetch_xordi */
    case 354:  /* atomic_fetch_ordi */
    case 353:  /* atomic_fetch_adddi */
    case 352:  /* atomic_fetch_andsi */
    case 351:  /* atomic_fetch_xorsi */
    case 350:  /* atomic_fetch_orsi */
    case 349:  /* atomic_fetch_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 348:  /* atomic_anddi */
    case 347:  /* atomic_xordi */
    case 346:  /* atomic_ordi */
    case 345:  /* atomic_adddi */
    case 344:  /* atomic_andsi */
    case 343:  /* atomic_xorsi */
    case 342:  /* atomic_orsi */
    case 341:  /* atomic_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 338:  /* mem_thread_fence_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 329:  /* *join2_loadhi */
    case 328:  /* *join2_loadhi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0));
      break;

    case 327:  /* *join2_load_storedf */
    case 326:  /* *join2_load_storesf */
    case 325:  /* *join2_load_storesi */
    case 324:  /* *join2_load_storehi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 1));
      break;

    case 323:  /* stack_tiedi */
    case 322:  /* stack_tiesi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 311:  /* call_value_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 310:  /* call_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 312:  /* call_value_multiple_internal */
    case 309:  /* sibcall_value_multiple_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 307:  /* sibcall_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 306:  /* eh_set_ra_di */
    case 305:  /* eh_set_ra_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 303:  /* simple_return_internal */
    case 302:  /* return_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 319:  /* bytepick_d */
    case 318:  /* bytepick_w */
    case 299:  /* probe_stack_rangedi */
    case 298:  /* probe_stack_rangesi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 296:  /* tablejumpdi */
    case 295:  /* tablejumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 294:  /* indirect_jumpdi */
    case 293:  /* indirect_jumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 292:  /* *jump_pic */
    case 291:  /* *jump_absolute */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 232:  /* *branch_equalitydi_inverted */
    case 231:  /* *branch_equalitysi_inverted */
    case 228:  /* *branch_orderdi_inverted */
    case 227:  /* *branch_ordersi_inverted */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 230:  /* branch_equalitydi */
    case 229:  /* branch_equalitysi */
    case 226:  /* *branch_orderdi */
    case 225:  /* *branch_ordersi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 224:  /* *branch_fp_inverted_FCCmode */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 223:  /* *branch_fp_FCCmode */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 214:  /* bstrpick_alsl_paired */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      break;

    case 199:  /* loongarch_lddir_d */
    case 198:  /* loongarch_lddir_w */
    case 197:  /* loongarch_cacop_d */
    case 196:  /* loongarch_cacop_w */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 2));
      break;

    case 201:  /* loongarch_ldpte_d */
    case 200:  /* loongarch_ldpte_w */
    case 195:  /* loongarch_iocsrwr_d */
    case 194:  /* loongarch_iocsrwr_w */
    case 193:  /* loongarch_iocsrwr_h */
    case 192:  /* loongarch_iocsrwr_b */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 1));
      break;

    case 187:  /* loongarch_csrxchg_d */
    case 186:  /* loongarch_csrxchg_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      break;

    case 185:  /* loongarch_csrwr_d */
    case 184:  /* loongarch_csrwr_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      break;

    case 191:  /* loongarch_iocsrrd_d */
    case 190:  /* loongarch_iocsrrd_w */
    case 189:  /* loongarch_iocsrrd_h */
    case 188:  /* loongarch_iocsrrd_b */
    case 183:  /* loongarch_csrrd_d */
    case 182:  /* loongarch_csrrd_w */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      break;

    case 315:  /* loongarch_movgr2fcsr */
    case 181:  /* loongarch_asrtgt_d */
    case 180:  /* loongarch_asrtle_d */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 179:  /* loongarch_break */
    case 178:  /* loongarch_syscall */
    case 176:  /* loongarch_dbar */
    case 175:  /* loongarch_ibar */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      break;

    case 340:  /* atomic_storedi */
    case 339:  /* atomic_storesi */
    case 337:  /* loongarch_crcc_w_d_w */
    case 336:  /* loongarch_crcc_w_w_w */
    case 335:  /* loongarch_crcc_w_h_w */
    case 334:  /* loongarch_crcc_w_b_w */
    case 333:  /* loongarch_crc_w_d_w */
    case 332:  /* loongarch_crc_w_w_w */
    case 331:  /* loongarch_crc_w_h_w */
    case 330:  /* loongarch_crc_w_b_w */
    case 171:  /* movgr2frhtf */
    case 170:  /* movgr2frhdi */
    case 169:  /* movgr2frhdf */
    case 160:  /* store_wordtf */
    case 159:  /* store_worddi */
    case 158:  /* store_worddf */
    case 157:  /* load_hightf */
    case 156:  /* load_highdi */
    case 155:  /* load_highdf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 321:  /* bitrev_8b */
    case 320:  /* bitrev_4b */
    case 317:  /* fclass_d */
    case 316:  /* fclass_s */
    case 314:  /* loongarch_movfcsr2gr */
    case 222:  /* revh_d */
    case 221:  /* revb_4h */
    case 220:  /* revb_2h */
    case 177:  /* loongarch_cpucfg */
    case 174:  /* movfrh2grtf */
    case 173:  /* movfrh2grdi */
    case 172:  /* movfrh2grdf */
    case 168:  /* got_load_tls_iedi */
    case 167:  /* got_load_tls_iesi */
    case 166:  /* got_load_tls_ledi */
    case 165:  /* got_load_tls_lesi */
    case 164:  /* got_load_tls_lddi */
    case 163:  /* got_load_tls_ldsi */
    case 162:  /* got_load_tls_gddi */
    case 161:  /* got_load_tls_gdsi */
    case 154:  /* load_lowtf */
    case 153:  /* load_lowdi */
    case 152:  /* load_lowdf */
    case 151:  /* frint_d */
    case 150:  /* frint_s */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 216:  /* alsldi3 */
    case 215:  /* alslsi3 */
    case 213:  /* zero_extend_ashift */
    case 149:  /* lu52i_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 148:  /* lu32i_d */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 137:  /* movfcc */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 136:  /* *movtf */
    case 135:  /* *movti */
    case 134:  /* *movdf_softfloat */
    case 133:  /* *movdf_hardfloat */
    case 132:  /* *movsf_softfloat */
    case 131:  /* *movsf_hardfloat */
    case 130:  /* *movqi_internal */
    case 129:  /* *movhi_internal */
    case 128:  /* *movsi_internal */
    case 127:  /* *movdi_64bit */
    case 126:  /* *movdi_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 125:  /* *insvdi */
    case 124:  /* *insvsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 106:  /* *zero_extendhi_truncqi */
    case 105:  /* *zero_extenddi_trunchi */
    case 104:  /* *zero_extendsi_trunchi */
    case 103:  /* *zero_extenddi_truncqi */
    case 102:  /* *zero_extendsi_truncqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 308:  /* sibcall_value_internal */
    case 94:  /* iorndi */
    case 93:  /* andndi */
    case 92:  /* iornsi */
    case 91:  /* andnsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 73:  /* sminadf3 */
    case 72:  /* sminasf3 */
    case 71:  /* smaxadf3 */
    case 70:  /* smaxasf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[1] = 2;
      break;

    case 57:  /* *rsqrtdfa */
    case 56:  /* *rsqrtsfa */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 250:  /* *sgeu_didi */
    case 249:  /* *sge_didi */
    case 248:  /* *sgeu_disi */
    case 247:  /* *sge_disi */
    case 246:  /* *sgeu_sisi */
    case 245:  /* *sge_sisi */
    case 238:  /* *sne_zero_didi */
    case 237:  /* *sne_zero_disi */
    case 236:  /* *sne_zero_sisi */
    case 235:  /* *seq_zero_didi */
    case 234:  /* *seq_zero_disi */
    case 233:  /* *seq_zero_sisi */
    case 219:  /* bswapdi2 */
    case 218:  /* bswapsi2 */
    case 217:  /* bswaphi2 */
    case 121:  /* floatdisf2 */
    case 120:  /* floatsisf2 */
    case 119:  /* floatdidf2 */
    case 118:  /* floatsidf2 */
    case 117:  /* fix_truncdfdi2 */
    case 116:  /* fix_truncdfsi2 */
    case 115:  /* fix_truncsfdi2 */
    case 114:  /* fix_truncsfsi2 */
    case 113:  /* extendsfdf2 */
    case 112:  /* extendqihi2 */
    case 111:  /* extendhidi2 */
    case 110:  /* extendhisi2 */
    case 109:  /* extendqidi2 */
    case 108:  /* extendqisi2 */
    case 107:  /* extendsidi2 */
    case 101:  /* zero_extendqihi2 */
    case 100:  /* zero_extendhidi2 */
    case 99:  /* zero_extendhisi2 */
    case 98:  /* zero_extendqidi2 */
    case 97:  /* zero_extendqisi2 */
    case 96:  /* *zero_extendsidi2_internal */
    case 95:  /* truncdfsf2 */
    case 79:  /* negdf2 */
    case 78:  /* negsf2 */
    case 77:  /* one_cmpldi2 */
    case 76:  /* one_cmplsi2 */
    case 75:  /* negdi2 */
    case 74:  /* negsi2 */
    case 65:  /* ctzdi2 */
    case 64:  /* ctzsi2 */
    case 63:  /* clzdi2 */
    case 62:  /* clzsi2 */
    case 61:  /* absdf2 */
    case 60:  /* abssf2 */
    case 55:  /* sqrtdf2 */
    case 54:  /* sqrtsf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 53:  /* *fnmadf4 */
    case 52:  /* *fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 51:  /* *fnmsdf4 */
    case 50:  /* *fnmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 49:  /* *fmsdf4 */
    case 48:  /* *fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 47:  /* *fmadf4 */
    case 46:  /* *fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 45:  /* fnmsdf4 */
    case 44:  /* fnmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 147:  /* *seldf */
    case 146:  /* *selsf */
    case 145:  /* *selnedi_using_di */
    case 144:  /* *seleqdi_using_di */
    case 143:  /* *selnesi_using_di */
    case 142:  /* *seleqsi_using_di */
    case 141:  /* *selnedi_using_si */
    case 140:  /* *seleqdi_using_si */
    case 139:  /* *selnesi_using_si */
    case 138:  /* *seleqsi_using_si */
    case 43:  /* fnmadf4 */
    case 42:  /* fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 41:  /* fmsdf4 */
    case 40:  /* fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 123:  /* *extzvdi */
    case 122:  /* *extzvsi */
    case 39:  /* fmadf4 */
    case 38:  /* fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 21:  /* umulsi3_highpart */
    case 20:  /* mulsi3_highpart */
    case 19:  /* umuldi3_highpart */
    case 18:  /* muldi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 90:  /* *nordi3 */
    case 89:  /* *norsi3 */
    case 16:  /* mulsidi3_64bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 210:  /* *lshrsi3_extend */
    case 209:  /* *ashrsi3_extend */
    case 208:  /* *ashlsi3_extend */
    case 59:  /* *rsqrtdfb */
    case 58:  /* *rsqrtsfb */
    case 17:  /* *mulsi3_extended */
    case 11:  /* *subsi3_extended */
    case 6:  /* *addsi3_extended */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 290:  /* sungt_df_using_FCCmode */
    case 289:  /* sunge_df_using_FCCmode */
    case 288:  /* sgt_df_using_FCCmode */
    case 287:  /* sge_df_using_FCCmode */
    case 286:  /* sne_df_using_FCCmode */
    case 285:  /* sltgt_df_using_FCCmode */
    case 284:  /* sordered_df_using_FCCmode */
    case 283:  /* sle_df_using_FCCmode */
    case 282:  /* slt_df_using_FCCmode */
    case 281:  /* seq_df_using_FCCmode */
    case 280:  /* sunle_df_using_FCCmode */
    case 279:  /* sunlt_df_using_FCCmode */
    case 278:  /* suneq_df_using_FCCmode */
    case 277:  /* sunordered_df_using_FCCmode */
    case 276:  /* sungt_sf_using_FCCmode */
    case 275:  /* sunge_sf_using_FCCmode */
    case 274:  /* sgt_sf_using_FCCmode */
    case 273:  /* sge_sf_using_FCCmode */
    case 272:  /* sne_sf_using_FCCmode */
    case 271:  /* sltgt_sf_using_FCCmode */
    case 270:  /* sordered_sf_using_FCCmode */
    case 269:  /* sle_sf_using_FCCmode */
    case 268:  /* slt_sf_using_FCCmode */
    case 267:  /* seq_sf_using_FCCmode */
    case 266:  /* sunle_sf_using_FCCmode */
    case 265:  /* sunlt_sf_using_FCCmode */
    case 264:  /* suneq_sf_using_FCCmode */
    case 263:  /* sunordered_sf_using_FCCmode */
    case 262:  /* *sleu_didi */
    case 261:  /* *sle_didi */
    case 260:  /* *sleu_disi */
    case 259:  /* *sle_disi */
    case 258:  /* *sleu_sisi */
    case 257:  /* *sle_sisi */
    case 256:  /* *sltu_didi */
    case 255:  /* *slt_didi */
    case 254:  /* *sltu_disi */
    case 253:  /* *slt_disi */
    case 252:  /* *sltu_sisi */
    case 251:  /* *slt_sisi */
    case 244:  /* *sgtu_didi */
    case 243:  /* *sgt_didi */
    case 242:  /* *sgtu_disi */
    case 241:  /* *sgt_disi */
    case 240:  /* *sgtu_sisi */
    case 239:  /* *sgt_sisi */
    case 212:  /* rotrdi3 */
    case 211:  /* rotrsi3 */
    case 207:  /* lshrdi3 */
    case 206:  /* ashrdi3 */
    case 205:  /* ashldi3 */
    case 204:  /* lshrsi3 */
    case 203:  /* ashrsi3 */
    case 202:  /* ashlsi3 */
    case 88:  /* *iorhi3 */
    case 87:  /* anddi3_extended */
    case 86:  /* andsi3_extended */
    case 85:  /* xordi3 */
    case 84:  /* iordi3 */
    case 83:  /* anddi3 */
    case 82:  /* xorsi3 */
    case 81:  /* iorsi3 */
    case 80:  /* andsi3 */
    case 69:  /* smindf3 */
    case 68:  /* sminsf3 */
    case 67:  /* smaxdf3 */
    case 66:  /* smaxsf3 */
    case 37:  /* umoddi3_fake */
    case 36:  /* moddi3_fake */
    case 35:  /* udivdi3_fake */
    case 34:  /* divdi3_fake */
    case 33:  /* *umoddi3 */
    case 32:  /* *moddi3 */
    case 31:  /* *udivdi3 */
    case 30:  /* *divdi3 */
    case 29:  /* *umodsi3 */
    case 28:  /* *modsi3 */
    case 27:  /* *udivsi3 */
    case 26:  /* *divsi3 */
    case 25:  /* *recipdf3 */
    case 24:  /* *recipsf3 */
    case 23:  /* *divdf3 */
    case 22:  /* *divsf3 */
    case 15:  /* muldi3 */
    case 14:  /* mulsi3 */
    case 13:  /* muldf3 */
    case 12:  /* mulsf3 */
    case 10:  /* subdi3 */
    case 9:  /* subsi3 */
    case 8:  /* subdf3 */
    case 7:  /* subsf3 */
    case 5:  /* adddi3 */
    case 4:  /* addsi3 */
    case 3:  /* adddf3 */
    case 2:  /* addsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 313:  /* nop */
    case 304:  /* loongarch_ertn */
    case 301:  /* *simple_return */
    case 300:  /* *return */
    case 297:  /* blockage */
    case 1:  /* trap */
      break;

    }
}
